// ___SETA43  _____
// 27/11/2024 _____
//RELOJ DS1307
//Arduino 1.8.19
//ESP8266
// seta43.duckdns.org
// seta43.blogspot.com
// Wemos ESP-Wroom-02 D1

#include "RTClib.h"

#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

#define OLED_RESET     -1   // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C // If not work please scan the bus
#define SDA 14         // D5
#define SCL 12         // D6

Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);


#include "Rotary.h"
/////////////////////////////////////////////////////////////////

#define ROTARY_PIN1 5 //D1
#define ROTARY_PIN2 4  //D2
#define BUTTON_PIN  0  //D3

#define CLICKS_PER_STEP 4   // this number depends on your rotary encoder
/////////////////////////////////////////////////////////////////
Rotary r;
/////////////////////////////////////////////////////////////////
RTC_DS1307 rtc;
/////////////////////////////////////////////////////////////////

int segundo,minuto,hora,dia,mes;
long anio; //variable año
DateTime HoraFecha;
char Nombres[8][7]= {"*","DIA  ", "MES  ", "YEAR ", "HORA ", "MIN. ",  "SEG. "};


 
int segundoOld;
char cadena[40];

int modo = 0; 

void setup() 
{
  Serial.begin(9600);
  while (!Serial) {;  }
  delay(500);
  Serial.println("\n\nSimple RELOJ ESP8266");
  
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(BUTTON_PIN, INPUT); 
  
  Wire.begin(SDA, SCL);
  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) 
        {
          while (1)  {Serial.println("SSD1306 allocation failed"); delay(1000); }
        }
  if (! rtc.begin()) 
        {   
          while (1)  {Serial.println("Couldn't find RTC"); delay(1000); }
        }
  display.display();
  delay(500);

  r.begin(ROTARY_PIN1, ROTARY_PIN2, CLICKS_PER_STEP);
  r.setLeftRotationHandler(showDirection);
  r.setRightRotationHandler(showDirection);
  
}

void loop() 
{
  delay(10);
  r.loop();

      if(modo==0)
        {
            HoraFecha = rtc.now(); //obtenemos la hora y fecha actual 
            segundo=HoraFecha.second();
            if(segundo!=segundoOld)
              { 
                digitalWrite(LED_BUILTIN, !digitalRead(LED_BUILTIN));
                segundoOld=segundo;
                minuto=HoraFecha.minute();
                hora=HoraFecha.hour();
                dia=HoraFecha.day();
                mes=HoraFecha.month();
                anio=HoraFecha.year();
                printLinea();
                printPanel();
               }
        }

     if (digitalRead(BUTTON_PIN) == 0) 
            {     
              delay(100);
              while(digitalRead(BUTTON_PIN) == 0) {;}
              modo = modo + 1;
              if (modo > 6) 
                  { 
                    modo = 0;
                    rtc.adjust(DateTime(anio, mes, dia, hora, minuto, segundo));
                  }
              printLinea(); 
              printPanel();
              Serial.println(modo);
            }

  
}


////////////RUTINAS/////////////

void printLinea(void)
{
  if(modo!=0) 
  {
    sprintf(cadena,"CAMBIO %s",Nombres[modo]);
    Serial.print(cadena);
  }
  sprintf(cadena,"%02d:%02d:%02d   %02d/%02d/%02d",hora,minuto,segundo,dia,mes,anio);
  Serial.println(cadena);
}


void printPanel(void)
{
  display.clearDisplay(); 

  if(modo!=0) 
  {   
    display.setTextSize(1);
    display.setCursor(0,52);
    sprintf(cadena,"CAMBIO %s",Nombres[modo]);
    display.print(cadena);

    switch(modo)
        {
          case 1:
               display.setCursor(0,37); 
          break;
          case 2:
              display.setCursor(36,37); 
          break;
          case 3:
              display.setCursor(96,37); 
          break;
          case 4:       
             display.setCursor(12,9); 
          break;
          case 5:       
             display.setCursor(48,9); 
          break;
          case 6:
            display.setCursor(84,9);        
          break;
        }
    display.setTextSize(2);  //12x
    display.print("--");
    
  }
   
  display.setTextSize(2);
  display.setTextColor(SSD1306_WHITE);
  
  sprintf(cadena," %02d:%02d:%02d",hora,minuto,segundo);
  display.setCursor(0,0); 
  display.print(cadena);

  sprintf(cadena,"%02d/%02d/%02d",dia,mes,anio);
  display.setCursor(0,28);
  display.print(cadena);

  display.display();
}

// on left or right rotation
void showDirection(Rotary& r) 
{
 int z;
  if(r.getDirection()==1) z=-1; else z=1;

  switch(modo)
    {
      case 1:
          dia+=z;
      break;
      case 2:
          mes+=z;
      break;
      case 3:
          anio+=z;
      break;
      case 4:       
         hora+=z;
      break;
      case 5:       
         minuto+=z;
      break;
      case 6:
        segundo+=z;       
      break;
    }
  printLinea();
  printPanel(); 
  Serial.println(z);
}
